# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define reltag _redhat_3
%define namedreltag -redhat-3
%global namedversion %{version}%{?namedreltag}

%define section free

%bcond_without mead
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define maven_version 20110809-redhat-3

Name:           sun-xsom
Version:        20110809
Release:        5%{?reltag}%{?dist}.3
Epoch:          0
Summary:        XML Schema Object Model
License:        CDDL
Group:          Development/Java

%if %with mead
Source100: com.sun.xsom-xsom-20110809-redhat-3-sources.zip
Source101: com.sun.xsom-xsom-20110809-redhat-3-patches.zip
Source102: xsom-20110809-redhat-3-sources.jar
Source103: xsom-20110809-redhat-3.pom
Source104: xsom-20110809-redhat-3.jar
Source105: xsom-20110809-redhat-3-javadoc.jar
%endif

URL:            https://xsom.dev.java.net/
%if 0
svn -q export -r 26 https://svn.java.net/svn/xsom~sources/tags/xsom-20110809 sun-xsom-20110809 && tar cjf sun-xsom-20110809.tar.bz2 sun-xsom-20110809
%endif
%if %without mead
Source0:        sun-xsom-20110809.tar.bz2
# XXX: this comes from jaxb-ri but creates a circular dependency
Source1:        LicenceTask.java
Patch0:         xsom-pom.patch
%endif
Provides:       xsom = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       relaxngDatatype
%if %without mead
# XXX: for LicenceTask.java
BuildRequires:  ant
# FIXME: conflict with jakarta-commons-cli
BuildRequires:  apache-commons-cli
# FIXME: conflict with jakarta-commons-logging
BuildRequires:  apache-commons-logging
BuildRequires:  java-devel
BuildRequires:  jboss-parent
BuildRequires:  jpackage-utils 
BuildRequires:  junit
BuildRequires:  jvnet-parent >= 0:1
BuildRequires:  relaxngDatatype
BuildRequires:  build-helper-maven-plugin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  msv-core
BuildRequires:  oss-parent
BuildRequires:  relaxngcc
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
XML Schema Object Model (XSOM) is a Java library that 
allows applications to easily parse XML Schema documents 
and inspect information in them. It is expected to be useful
for applications that need to take XML Schema as an input. 
The library is a straight-forward implement of 
"schema components" as defined in the XML Schema spec part 1. 
Refer to this specification of how this object model works. 

%package javadoc
Summary:        Javadoc for xsom
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%{_bindir}/find -type f -name "*.jar" | %{_bindir}/xargs -t %{__rm}
%{__mkdir_p} com/sun/tools
%{__cp} -p %{SOURCE1} com/sun/tools/LicenceTask.java
%{javac} -classpath `%{_bindir}/build-classpath ant/ant` com/sun/tools/LicenceTask.java
%{jar} cf lib/lic.jar com/sun/tools/LicenceTask.class
%{__ln_s} `%{_bindir}/build-classpath relaxngcc` lib/relaxngcc.jar
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
# XXX: tests require network (stall)
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip=true javadoc:aggregate deploy
%define prevversion 20110101-redhat-2
for d in `%{_bindir}/find maven2-brew -type d -name %{prevversion}`; do
    %{__mv} ${d}/* `/bin/echo ${d} | %{__sed} -e 's|%{prevversion}|%{namedversion}|;'`/
    %{__rm} -r ${d}/
done
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p maven2-brew/com/sun/xsom/xsom/%{namedversion}/xsom-%{namedversion}-sources.jar %{buildroot}%{_javadir}/xsom-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/xsom/xsom/%{namedversion}/xsom-%{namedversion}.jar %{buildroot}%{_javadir}/xsom-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/xsom-%{namedversion}-sources.jar %{buildroot}%{_javadir}/xsom-%{namedversion}-sources.jar                                                      
%{__cp} -p %{_sourcedir}/xsom-%{namedversion}.jar %{buildroot}%{_javadir}/xsom-%{namedversion}.jar                                                                      
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p maven2-brew/com/sun/xsom/xsom/%{namedversion}/xsom-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-xsom.pom
%else
%{__cp} -p %{_sourcedir}/xsom-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-xsom.pom
%endif
# depmaps
%add_to_maven_depmap com.sun.xsom xsom %{namedversion} JPP xsom
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/xsom

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/xsom-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/xsom-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/xsom-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/xsom-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/xsom-%{namedversion}/META-INF
%endif
%{__ln_s} xsom-%{namedversion} %{buildroot}%{_javadocdir}/xsom

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%{__unzip} -qq %{_sourcedir}/com.sun.xsom-xsom-%{namedversion}-sources.zip
%{__cp} xsom/license.txt ./
%{__rm} -rf xsom

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc license.txt
%{_javadir}*/xsom-%{namedversion}-sources.jar
%{_javadir}*/xsom-sources.jar
%{_javadir}*/xsom-%{namedversion}.jar
%{_javadir}*/xsom.jar
%{_mavenpomdir}/JPP-xsom.pom
%{_mavendepmapfragdir}/xsom

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/xsom-%{namedversion}
%{_javadocdir}/xsom

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-5_redhat_3.3
- Rebuild for MD5

* Thu Sep 06 2012 Paul Gier <pgier@redhat.com> - 0:20110809-4_redhat_3.4
- Update pom patch to fix dependency on relaxngcc

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-4_redhat_2.3
- Rebuild unsigned

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-4_redhat_2.2
- Rebuild unsigned

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-4_redhat_1.1
- Rebuild unsigned

* Fri Jul 27 2012 Hui Wang <huwang@redhat.com> - 0:20110809-4_redhat_1
- Add license.txt to %%files

* Mon Jul 23 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-3_redhat_1.1
- Rebuild using cache signing

* Fri Jul 20 2012 Hui Wang <huwang@redhat.com> 0:20110809-3_redhat_1
- First mead build

* Sat May 05 2012 David Walluck <dwalluck@redhat.com> 0:20110809-2
- use com.github.relaxng not relaxngDatatype for groupId
- resolves JBPAPP-8931

* Tue May 01 2012 David Walluck <dwalluck@redhat.com> 0:20110809-1
- 20110809
- recreate pom patch
- remove unused pom
- add BuildRequires: jvnet-parent

* Wed Feb 22 2012 David Walluck <dwalluck@redhat.com> 0:20110101-0.1
- 20110101

* Tue Feb 21 2012 David Walluck <dwalluck@redhat.com> 0:20070515-4.1
- add pom patch
- fix file names
- fix file location
- fix repolib dir ownership
- fix mvn deploy-file
- fix build

* Fri Dec 24 2010 Hui Wang <huwang@redhat.com> - 0:20070515-4
- Add repolib

* Wed Dec 08 2010 Hui Wang <huwang@redhat.com> - 0:20070515-3
- Fix %%files for signed jars

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:20070515-2.2.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:20070515-2.2
- Rebuild

* Mon Jan 18 2010 Yiqiao Wang <yiwang@redhat.com> 0:20070515-2.1.1
- Disable aot compiler

* Fri Jun 12 2009 Martha Benitez <mbenitez@redhat.com> 0:20070515-2.1
- Comment out relaxng
- Comment out retroweaver
- Build without package jdk14

* Fri Oct 10 2008 David Walluck <dwalluck@redhat.com> 0:20070515-2
- build for JPackage 5

* Tue Nov 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:20070515-1jpp
- First release
